/********************************************************************************
  output/fileyuv.hh

  purpose:
    YUV-file output.

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de

  modifications:
   13/Jun/2000 - Dirk Farin
    - first implementation

 ********************************************************************************
    Copyright (C) 1999  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef DVDVIEW_OUTPUT_FILEYUV_HH
#define DVDVIEW_OUTPUT_FILEYUV_HH

#include "output/output.hh"
#include "ulib/graphics/fileio/write_yuv.hh"
#include <fstream.h>


class VideoOutput_YUVFile : public VideoOutput_Class
{
public:
   VideoOutput_YUVFile();
  ~VideoOutput_YUVFile();

  void Show_const(const Image_YUV<Pixel>& img);

private:
  FileWriter_YUV1 writer;
  ofstream ostr;
};

#endif
