/********************************************************************************
  video12/output.hh

  purpose:

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de

  modifications:
    16/Apr/2000 - Dirk Farin
     - new method: FreePictureData()
    04/Oct/1999 - Dirk Farin
     - integration into new architecture (code extracted out of
       old vsink.h)
    05/May/1999 - Dirk Farin
     - interface definition
 ********************************************************************************
    Copyright (C) 1999  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef DVDVIEW_VIDEO12_OUTPUT_HH
#define DVDVIEW_VIDEO12_OUTPUT_HH

#include "ulib/graphics/basic/image.hh"
#include "video12/vidsyntax.hh"
#include "system/system1.hh"



struct DecodedImageData
{
  DecodedImageData()
    : m_IsDirectBuffer(false),
      m_picdata_needed(false),
      m_picdata1(NULL), m_picdata2(NULL)
    { }

  virtual ~DecodedImageData() { }

  Image_YUV<Pixel> m_image;
  bool m_IsDirectBuffer; /* Data goes directly to the display.
			    The decoder will have to wait for the PTS before decoding.
			    In the other case, the decoder will decode as soon as
			    possible and wait for the PTS before actually sending
			    the output data.
			 */

  bool m_picdata_needed;
  
  PictureData* m_picdata1; //  first field or frame
  PictureData* m_picdata2; //  second field

  SystemTimingInformation m_timing; /* When two fields are contained, the times for
				       the first one. */


  void FreePictureData()
  {
    if (m_picdata1) PictureData::FreePictureData(m_picdata1);
    if (m_picdata2) PictureData::FreePictureData(m_picdata2);
    m_picdata1 = m_picdata2 = NULL;
  }
};



class DecodedPictureSink
{
public:
  virtual ~DecodedPictureSink() { }

  virtual DecodedImageData* GetOutputBuffer(ImageSpec_YUV spec,uint3 picture_type,
					    bool maymodify) = 0;
  virtual void              ShowOutputBuffer(DecodedImageData*) = 0;
  virtual void              FreeOutputBuffer(DecodedImageData*) = 0;

  virtual bool  NeedsPictureData(uint3 pictype) const { return false; }
  virtual bool  NeedsMBData     (uint3 pictype) const { return false; }
};

#endif
