/*********************************************************************
  ulib/graphics/visualize/motionfield.hh

  purpose:
    Overlay of motion vector field.

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de
     University Mannheim, Dept. Circuitry and Simulation
     B 6,26 EG, room 0.10 / D-68131 Mannheim / Germany

  modifications:
    1999/Oct/29 - Dirk Farin - first revision
 *********************************************************************/

#ifndef ULIB_GRAPHICS_VISUALIZE_MOTIONFIELD_HH
#define ULIB_GRAPHICS_VISUALIZE_MOTIONFIELD_HH

#include "ulib/graphics/datatypes/motionfield.hh"
#include "ulib/graphics/basic/image.hh"

#if 0
struct MotionVector
{
  int h,v;
};


struct MotionVectorField
{
  Bitmap<MotionVector> mv;
  int blksize_h,blksize_v;
  int nblks_h  ,nblks_v;
};
#endif


class MotionFieldVisualizer
{
public:
  MotionFieldVisualizer() : d_vectorcolor(255), d_drawarrows(false), d_scale(1.0) { }

  void SetLumaVal(Pixel p) { d_vectorcolor=p; }
  void DrawArrows(bool flag) { d_drawarrows=flag; }
  void SetScale(double s) { d_scale=s; }

  void Overlay(Image_YUV<Pixel>&,const MotionVectorField&,const Bitmap<bool>* colored=NULL) const;

private:
  Pixel  d_vectorcolor;
  bool   d_drawarrows;
  double d_scale;
};

#endif

